//--------------------
// read encoders
//--------------------
void check_chA1(){
  chA1_value = digitalRead(chA1);
  if (chA1_value == LOW){ // clockwise
    angle_count++;
  }
  else if (chA1_value == HIGH){// counterclockwise
    angle_count--;
  }
  angle = 0.00503*angle_count;
}

void check_chA2(){
  chA2_value = digitalRead(chA2);
  if (chA2_value == LOW){ // clockwise
    pos_count++;
  }
  else if (chA2_value == HIGH){ // counterclockwise
    pos_count--;
  }
  pos = 0.505*pos_count*0.0001;
}

//--------------------
// estimate velocities
//--------------------
ISR(TIMER2_OVF_vect) {  
  TCNT2 = tcnt2; // reload initial value of Timer2
  t++;
  if (t >= minSamplePeriod){
    //First subtract the oldest velocity value from running total
     angular_velocity = angular_velocity - angRunAvg[ind];
     cart_velocity = cart_velocity - posRunAvg[ind]; 
     
     // Then, calculate current velocity (divide by samples so it can be directly
     // added to the running total and represent the actual average value without dividing)
     angRunAvg[ind] = (angle-angle1)*1000/(minSamplePeriod * samples);
     posRunAvg[ind] = (pos-pos1)*1000/(minSamplePeriod * samples);
     
     // Add current normalized velocity to running total
     angular_velocity = angular_velocity + angRunAvg[ind];
     cart_velocity = cart_velocity + posRunAvg[ind]; 
     
     //Advance index, reset to zero 
     ind++;
     if (ind > 4){
       ind = 0;
     }
     //update previous position/angle and reset timer
     angle1 = angle;
     pos1 = pos; 
     t = 0;
  }
}
