clear;clc;

Pmax = 413405.16;
f = 6.664;
Mc = 0.43;
Mp = 0.21;
lp = 0.262;
a = 0.0002849;
Ip = Mp*lp^2/12;
g = 9.8;

A1 = g*(Mc+Mp)*Mp*lp/(Mc*Mp*lp^2+Mc*Ip+Mp*Ip);
A2 = Mp^2*lp^2*g/(Mc*Mp*lp^2+Mc*Ip+Mp*Ip);
A = [0 1 0 0;A1 0 0 0;0 0 0 1;0 A2 0 0];
B1 = -Pmax*a*Mp*lp/(5*(Mc*Mp*lp^2+Mc*Ip+Mp*Ip));
B2 = -Pmax*a*(Mp*Ip^2+Ip)/(5*(Mc*Mp*lp^2+Mc*Ip+Mp*Ip));
B = [0;B1;0;B2];
C = eye(4);
D = 0;

t = 0:0.01:10;
u = 0*t;
x0 = [1;0;0;0];

sys = ss(A,B,C,D);
% figure(1); lsim(sys,u,t,x0);

Q = diag([10 1 1 1]);
R = 500;
[K, S, EIG] = lqr(A, B, Q, R);

sys_fb = feedback(sys,K);
[Y,T] = lsim(sys_fb,u,t,x0);
% figure(2); 
% subplot(4,1,1); plot(t,Y(:,1));
% subplot(4,1,2); plot(t,Y(:,2));
% subplot(4,1,3); plot(t,Y(:,3));
% subplot(4,1,4); plot(t,Y(:,4));

for i=1:length(t)
    input(i) = -K*Y(i,:)'+5;
end
% figure(3); plot(t,input);
K
