(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     36030,       1210]
NotebookOptionsPosition[     32955,       1100]
NotebookOutlinePosition[     33298,       1115]
CellTagsIndexPosition[     33255,       1112]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["M", "c"], "+", 
        SubscriptBox["M", "p"]}], ")"}], "*", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "c"], "''"}], "[", "t", "]"}]}], "+", 
     RowBox[{
      SubscriptBox["M", "p"], "*", 
      SubscriptBox["l", "p"], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"alfa", "[", "t", "]"}], "]"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"alfa", "'"}], "[", "t", "]"}], ")"}], "^", "2"}]}], "-", 
     RowBox[{
      SubscriptBox["M", "p"], "*", 
      SubscriptBox["l", "p"], "*", 
      RowBox[{"Cos", "[", 
       RowBox[{"alfa", "[", "t", "]"}], "]"}], "*", 
      RowBox[{
       RowBox[{"alfa", "''"}], "[", "t", "]"}]}]}], "==", 
    RowBox[{
     RowBox[{
      SubscriptBox["P", "max"], "*", "a"}], "-", 
     RowBox[{
      SubscriptBox["P", "max"], "*", "a", "*", 
      RowBox[{"u", "/", "5"}]}]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5335233775878954`*^9, 3.5335234243055677`*^9}, {
  3.533523492642476*^9, 3.533523660929102*^9}, {3.5335237223136125`*^9, 
  3.533523722511624*^9}, {3.5335240154073763`*^9, 3.533524061922037*^9}, {
  3.5335241120369034`*^9, 3.5335241123909235`*^9}, {3.5335255294779763`*^9, 
  3.5335255311010695`*^9}, {3.533526644174733*^9, 3.533526644774768*^9}},
 FontFamily->"Courier New"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq2", ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubscriptBox["M", "p"], "*", 
         RowBox[{
          SubscriptBox["l", "p"], "^", "2"}]}], "+", "Ip"}], ")"}], "*", 
      RowBox[{
       RowBox[{"alfa", "''"}], "[", "t", "]"}]}], "-", 
     RowBox[{
      SubscriptBox["M", "p"], "*", 
      SubscriptBox["l", "p"], "*", 
      RowBox[{"Cos", "[", 
       RowBox[{"alfa", "[", "t", "]"}], "]"}], "*", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "c"], "''"}], "[", "t", "]"}]}], "-", 
     RowBox[{
      SubscriptBox["M", "p"], "*", "g", "*", 
      SubscriptBox["l", "p"], "*", 
      RowBox[{"Sin", "[", 
       RowBox[{"alfa", "[", "t", "]"}], "]"}]}]}], "\[Equal]", "0"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5335237561405473`*^9, 3.5335237976829233`*^9}, {
  3.5335238330579467`*^9, 3.533523899992775*^9}, {3.533523957170046*^9, 
  3.5335239587991385`*^9}, {3.5335241244876156`*^9, 3.5335241248606367`*^9}, {
  3.5335266486219873`*^9, 3.5335266495460405`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"eq1", " ", "&&", " ", "eq2"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"alfa", "''"}], "[", "t", "]"}], ",", 
        RowBox[{
         RowBox[{
          SubscriptBox["x", "c"], "''"}], "[", "t", "]"}]}], "}"}]}], "]"}], "//",
     "FullSimplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.533523996176276*^9, 3.5335240096010447`*^9}, {
   3.533524132520075*^9, 3.533524170528249*^9}, {3.5335243880976934`*^9, 
   3.5335243891517534`*^9}, {3.533524471805481*^9, 3.5335244764127445`*^9}, {
   3.533525600789055*^9, 3.5335256249544373`*^9}, 3.5335266612887125`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"alfa", "''"}], "[", "t", "]"}], "/.", "sol"}]], "Input",
 CellChangeTimes->{{3.5335246168027744`*^9, 3.533524650579706*^9}, {
  3.533524776632916*^9, 3.533524794969965*^9}, {3.533526709293458*^9, 
  3.5335267098284883`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"a", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "5"}], "+", "u"}], ")"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
        SubscriptBox["P", "max"]}], "-", 
       RowBox[{"5", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g", " ", 
           SubscriptBox["M", "c"]}], "+", 
          RowBox[{
           SubscriptBox["M", "p"], " ", 
           RowBox[{"(", 
            RowBox[{"g", "-", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
              SubscriptBox["l", "p"], " ", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["alfa", "\[Prime]",
                 MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
            ")"}]}]}], ")"}]}]}], ")"}]}], 
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubscriptBox["M", "c"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
       RowBox[{
        SubscriptBox["M", "p"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Sin", "[", 
             RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5335246241341934`*^9, 3.5335246516017647`*^9}, {
   3.533524783588314*^9, 3.533524795946021*^9}, 3.533525696008501*^9, 
   3.533526711006556*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["x", "c"], "''"}], "[", "t", "]"}], "/.", "sol"}]], "Input",
 CellChangeTimes->{{3.533524804120488*^9, 3.5335248201224036`*^9}, {
  3.5335267167358837`*^9, 3.533526717268914*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox[
   RowBox[{
    RowBox[{"5", " ", "g", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"2", " ", 
       RowBox[{"alfa", "[", "t", "]"}]}], "]"}], " ", 
     SubsuperscriptBox["l", "p", "2"], " ", 
     SubsuperscriptBox["M", "p", "2"]}], "-", 
    RowBox[{"2", " ", "a", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "5"}], "+", "u"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}], " ", 
     SubscriptBox["P", "max"]}], "-", 
    RowBox[{"10", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["alfa", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
   RowBox[{"10", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubscriptBox["M", "c"], " ", 
       RowBox[{"(", 
        RowBox[{"Ip", "+", 
         RowBox[{
          SubsuperscriptBox["l", "p", "2"], " ", 
          SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
      RowBox[{
       SubscriptBox["M", "p"], " ", 
       RowBox[{"(", 
        RowBox[{"Ip", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"Sin", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
          SubsuperscriptBox["l", "p", "2"], " ", 
          SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}]], "}"}]], "Output",
 CellChangeTimes->{3.5335248221905217`*^9, 3.533525698016616*^9, 
  3.533526717911951*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"f1", "=", 
   RowBox[{
    RowBox[{"alfa", "'"}], "[", "t", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"alfa", "''"}], "[", "t", "]"}], "/.", "sol"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f3", "=", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "c"], "'"}], "[", "t", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f4", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "c"], "''"}], "[", "t", "]"}], "/.", "sol"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5335285526328907`*^9, 3.5335286179936295`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a11", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f1", ",", 
     RowBox[{"alfa", "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335286278721943`*^9, 3.533528666454401*^9}, 
   3.5335287860362406`*^9, 3.5335288501619086`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.533528853895122*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a12", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f1", ",", 
     RowBox[{
      RowBox[{"alfa", "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.533528684932458*^9, 3.533528711558981*^9}, 
   3.5335287891364183`*^9, 3.533528856061246*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.5335288570953054`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a13", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f1", ",", 
     RowBox[{
      SubscriptBox["x", "c"], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335287141461287`*^9, 3.533528746352971*^9}, 
   3.533528792557614*^9, 3.533528858873407*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.533528859895465*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a14", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f1", ",", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "c"], "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.533528750317198*^9, 3.533528759494723*^9}, 
   3.53352879528977*^9, 3.5335288615255585`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.533528862578619*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"a21", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f2", ",", 
     RowBox[{"alfa", "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a21", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"alfa", "[", "t", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"alfa", "'"}], "[", "t", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{"u", "\[Rule]", "5"}]}], "}"}]}], "//", 
  "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.5335287688622584`*^9, 3.5335288024161777`*^9}, {
  3.5335288888311205`*^9, 3.533528970041765*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SubscriptBox["M", "c"], " ", 
            RowBox[{"(", 
             RowBox[{"Ip", "+", 
              RowBox[{
               SubsuperscriptBox["l", "p", "2"], " ", 
               SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
           RowBox[{
            SubscriptBox["M", "p"], " ", 
            RowBox[{"(", 
             RowBox[{"Ip", "+", 
              RowBox[{
               SuperscriptBox[
                RowBox[{"Sin", "[", 
                 RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
               SubsuperscriptBox["l", "p", "2"], " ", 
               SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "5"}], " ", "g", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["M", "c"], "+", 
             SubscriptBox["M", "p"]}], ")"}]}], "-", 
          RowBox[{"a", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", "u"}], ")"}], " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
           SubscriptBox["P", "max"]}], "+", 
          RowBox[{"5", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", 
             RowBox[{"alfa", "[", "t", "]"}]}], "]"}], " ", 
           SubscriptBox["l", "p"], " ", 
           SubscriptBox["M", "p"], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["alfa", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], 
       "+", 
       RowBox[{"2", " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubsuperscriptBox["M", "p", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"a", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", "u"}], ")"}], " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
           SubscriptBox["P", "max"]}], "-", 
          RowBox[{"5", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g", " ", 
              SubscriptBox["M", "c"]}], "+", 
             RowBox[{
              SubscriptBox["M", "p"], " ", 
              RowBox[{"(", 
               RowBox[{"g", "-", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
                 SubscriptBox["l", "p"], " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["alfa", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"5", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubscriptBox["M", "c"], " ", 
         RowBox[{"(", 
          RowBox[{"Ip", "+", 
           RowBox[{
            SubsuperscriptBox["l", "p", "2"], " ", 
            SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
        RowBox[{
         SubscriptBox["M", "p"], " ", 
         RowBox[{"(", 
          RowBox[{"Ip", "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"Sin", "[", 
              RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
            SubsuperscriptBox["l", "p", "2"], " ", 
            SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}], "2"]}], ")"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.533528814067844*^9, 3.5335288142678556`*^9}, 
   3.533528866949869*^9, {3.533528962469332*^9, 3.5335289711848307`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox[
   RowBox[{"g", " ", 
    SubscriptBox["l", "p"], " ", 
    SubscriptBox["M", "p"], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["M", "c"], "+", 
      SubscriptBox["M", "p"]}], ")"}]}], 
   RowBox[{
    RowBox[{"Ip", " ", 
     SubscriptBox["M", "p"]}], "+", 
    RowBox[{
     SubscriptBox["M", "c"], " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}]}]}]], "}"}]], "Output",
 CellChangeTimes->{{3.533528814067844*^9, 3.5335288142678556`*^9}, 
   3.533528866949869*^9, {3.533528962469332*^9, 3.5335289711998315`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"a22", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f2", ",", 
     RowBox[{
      RowBox[{"alfa", "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a22", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"alfa", "[", "t", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"alfa", "'"}], "[", "t", "]"}], "\[Rule]", "0"}]}], "}"}]}], "//",
   "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.5335290495213113`*^9, 3.5335290932928147`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"2", " ", 
       RowBox[{"alfa", "[", "t", "]"}]}], "]"}], " ", 
     SubsuperscriptBox["l", "p", "2"], " ", 
     SubsuperscriptBox["M", "p", "2"], " ", 
     RowBox[{
      SuperscriptBox["alfa", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], 
    RowBox[{
     RowBox[{
      SubscriptBox["M", "c"], " ", 
      RowBox[{"(", 
       RowBox[{"Ip", "+", 
        RowBox[{
         SubsuperscriptBox["l", "p", "2"], " ", 
         SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
     RowBox[{
      SubscriptBox["M", "p"], " ", 
      RowBox[{"(", 
       RowBox[{"Ip", "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", 
           RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
         SubsuperscriptBox["l", "p", "2"], " ", 
         SubscriptBox["M", "p"]}]}], ")"}]}]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.533529064595174*^9, 3.533529094222868*^9}}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{{3.533529064595174*^9, 3.533529094239869*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a23", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f2", ",", 
     RowBox[{
      SubscriptBox["x", "c"], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335291024603395`*^9, 3.5335291413285627`*^9}}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{{3.533529116357134*^9, 3.533529143243672*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a24", "=", 
  RowBox[{"a14", "=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{"f2", ",", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "c"], "'"}], "[", "t", "]"}]}], "]"}], "//", 
    "FullSimplify"}]}]}]], "Input",
 CellChangeTimes->{{3.5335291204163666`*^9, 3.533529132056032*^9}}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{3.5335291459428263`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a31", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f3", ",", 
     RowBox[{"alfa", "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335291839279985`*^9, 3.5335291964727163`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5335291975327773`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a32", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f3", ",", 
     RowBox[{
      RowBox[{"alfa", "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335291991268682`*^9, 3.533529233933859*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5335292179189434`*^9, 3.5335292352009315`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a33", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f3", ",", 
     RowBox[{
      SubscriptBox["x", "c"], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.533529237467061*^9, 3.5335292514668617`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.533529252905944*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a34", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f3", ",", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "c"], "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335292595933266`*^9, 3.5335292720190372`*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.533529274475178*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"a41", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f4", ",", 
     RowBox[{"alfa", "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a41", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"alfa", "[", "t", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"alfa", "'"}], "[", "t", "]"}], "\[Rule]", "0"}]}], "}"}]}], "//",
   "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.5335292763032827`*^9, 3.533529310509239*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"10", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SubscriptBox["M", "c"], " ", 
           RowBox[{"(", 
            RowBox[{"Ip", "+", 
             RowBox[{
              SubsuperscriptBox["l", "p", "2"], " ", 
              SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
          RowBox[{
           SubscriptBox["M", "p"], " ", 
           RowBox[{"(", 
            RowBox[{"Ip", "+", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"Sin", "[", 
                RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
              SubsuperscriptBox["l", "p", "2"], " ", 
              SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"g", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", " ", 
             RowBox[{"alfa", "[", "t", "]"}]}], "]"}], " ", 
           SubscriptBox["l", "p"], " ", 
           SubscriptBox["M", "p"]}], "-", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"Ip", "+", 
             RowBox[{
              SubsuperscriptBox["l", "p", "2"], " ", 
              SubscriptBox["M", "p"]}]}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["alfa", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], 
       "-", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"2", " ", 
          RowBox[{"alfa", "[", "t", "]"}]}], "]"}], " ", 
        SubscriptBox["l", "p"], " ", 
        SubscriptBox["M", "p"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"5", " ", "g", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"2", " ", 
             RowBox[{"alfa", "[", "t", "]"}]}], "]"}], " ", 
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubsuperscriptBox["M", "p", "2"]}], "-", 
          RowBox[{"2", " ", "a", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", "u"}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"Ip", "+", 
             RowBox[{
              SubsuperscriptBox["l", "p", "2"], " ", 
              SubscriptBox["M", "p"]}]}], ")"}], " ", 
           SubscriptBox["P", "max"]}], "-", 
          RowBox[{"10", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
           SubscriptBox["l", "p"], " ", 
           SubscriptBox["M", "p"], " ", 
           RowBox[{"(", 
            RowBox[{"Ip", "+", 
             RowBox[{
              SubsuperscriptBox["l", "p", "2"], " ", 
              SubscriptBox["M", "p"]}]}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["alfa", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}]}], 
      ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"10", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubscriptBox["M", "c"], " ", 
         RowBox[{"(", 
          RowBox[{"Ip", "+", 
           RowBox[{
            SubsuperscriptBox["l", "p", "2"], " ", 
            SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
        RowBox[{
         SubscriptBox["M", "p"], " ", 
         RowBox[{"(", 
          RowBox[{"Ip", "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"Sin", "[", 
              RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
            SubsuperscriptBox["l", "p", "2"], " ", 
            SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}], "2"]}], ")"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.533529286650874*^9, 3.533529312593358*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox[
   RowBox[{"g", " ", 
    SubsuperscriptBox["l", "p", "2"], " ", 
    SubsuperscriptBox["M", "p", "2"]}], 
   RowBox[{
    RowBox[{"Ip", " ", 
     SubscriptBox["M", "p"]}], "+", 
    RowBox[{
     SubscriptBox["M", "c"], " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}]}]}]], "}"}]], "Output",
 CellChangeTimes->{{3.533529286650874*^9, 3.5335293126043587`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"a42", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f4", ",", 
     RowBox[{
      RowBox[{"alfa", "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a42", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"alfa", "[", "t", "]"}], "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"alfa", "'"}], "[", "t", "]"}], "\[Rule]", "0"}]}], "}"}]}], "//",
   "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.5335293393008857`*^9, 3.533529386302574*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}], " ", 
     RowBox[{
      SuperscriptBox["alfa", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], 
    RowBox[{
     RowBox[{
      SubscriptBox["M", "c"], " ", 
      RowBox[{"(", 
       RowBox[{"Ip", "+", 
        RowBox[{
         SubsuperscriptBox["l", "p", "2"], " ", 
         SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
     RowBox[{
      SubscriptBox["M", "p"], " ", 
      RowBox[{"(", 
       RowBox[{"Ip", "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", 
           RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
         SubsuperscriptBox["l", "p", "2"], " ", 
         SubscriptBox["M", "p"]}]}], ")"}]}]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5335293581929665`*^9, 3.5335293875736465`*^9}}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{{3.5335293581929665`*^9, 3.5335293875896473`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a43", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f4", ",", 
     RowBox[{
      SubscriptBox["x", "c"], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335293902538*^9, 3.533529402564504*^9}}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{3.53352940300653*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a44", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f4", ",", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "c"], "'"}], "[", "t", "]"}]}], "]"}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.5335294067977467`*^9, 3.533529415672254*^9}}],

Cell[BoxData[
 RowBox[{"{", "0", "}"}]], "Output",
 CellChangeTimes->{3.5335294174743567`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b11", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f1", ",", "u"}], "]"}], "//", "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.533529447496074*^9, 3.533529478052822*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.533529479080881*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"b21", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f2", ",", "u"}], "]"}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b21", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"alfa", "[", "t", "]"}], "\[Rule]", "0"}], "}"}]}], "//", 
  "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.533529481775035*^9, 3.533529528147687*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{"a", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"alfa", "[", "t", "]"}], "]"}], " ", 
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     SubscriptBox["P", "max"]}], 
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubscriptBox["M", "c"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
       RowBox[{
        SubscriptBox["M", "p"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Sin", "[", 
             RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.533529495576824*^9, 3.5335295294827633`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{"a", " ", 
     SubscriptBox["l", "p"], " ", 
     SubscriptBox["M", "p"], " ", 
     SubscriptBox["P", "max"]}], 
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Ip", " ", 
        SubscriptBox["M", "p"]}], "+", 
       RowBox[{
        SubscriptBox["M", "c"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.533529495576824*^9, 3.533529529525766*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b31", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f3", ",", "u"}], "]"}], "//", "FullSimplify"}]}]], "Input",
 CellChangeTimes->{{3.53353010847288*^9, 3.533530118512454*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.533530121205608*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"b41", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{"f4", ",", "u"}], "]"}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b41", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"alfa", "[", "t", "]"}], "\[Rule]", "0"}], "}"}]}], "//", 
  "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.533530124371789*^9, 3.533530152813416*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{"a", " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}], " ", 
     SubscriptBox["P", "max"]}], 
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubscriptBox["M", "c"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}], "+", 
       RowBox[{
        SubscriptBox["M", "p"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Sin", "[", 
             RowBox[{"alfa", "[", "t", "]"}], "]"}], "2"], " ", 
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5335301349383936`*^9, 3.533530153945481*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{"a", " ", 
     RowBox[{"(", 
      RowBox[{"Ip", "+", 
       RowBox[{
        SubsuperscriptBox["l", "p", "2"], " ", 
        SubscriptBox["M", "p"]}]}], ")"}], " ", 
     SubscriptBox["P", "max"]}], 
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Ip", " ", 
        SubscriptBox["M", "p"]}], "+", 
       RowBox[{
        SubscriptBox["M", "c"], " ", 
        RowBox[{"(", 
         RowBox[{"Ip", "+", 
          RowBox[{
           SubsuperscriptBox["l", "p", "2"], " ", 
           SubscriptBox["M", "p"]}]}], ")"}]}]}], ")"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5335301349383936`*^9, 3.5335301539604816`*^9}}]
}, Open  ]]
},
WindowSize->{756, 553},
WindowMargins->{{2, Automatic}, {Automatic, 52}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1431, 40, 52, "Input"],
Cell[1991, 62, 1093, 31, 31, "Input"],
Cell[3087, 95, 716, 18, 31, "Input"],
Cell[CellGroupData[{
Cell[3828, 117, 271, 6, 31, "Input"],
Cell[4102, 125, 1978, 58, 56, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6117, 188, 243, 6, 31, "Input"],
Cell[6363, 196, 1808, 55, 56, "Output"]
}, Open  ]],
Cell[8186, 254, 669, 24, 92, "Input"],
Cell[CellGroupData[{
Cell[8880, 282, 299, 8, 31, "Input"],
Cell[9182, 292, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9289, 298, 317, 9, 31, "Input"],
Cell[9609, 309, 72, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9718, 315, 318, 9, 31, "Input"],
Cell[10039, 326, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10146, 332, 340, 10, 31, "Input"],
Cell[10489, 344, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10596, 350, 641, 19, 52, "Input"],
Cell[11240, 371, 4224, 118, 121, "Output"],
Cell[15467, 491, 681, 21, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16185, 517, 570, 18, 52, "Input"],
Cell[16758, 537, 1022, 31, 56, "Output"],
Cell[17783, 570, 116, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17936, 577, 272, 8, 31, "Input"],
Cell[18211, 587, 116, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18364, 594, 325, 10, 31, "Input"],
Cell[18692, 606, 94, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18823, 613, 249, 7, 31, "Input"],
Cell[19075, 622, 72, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19184, 628, 269, 8, 31, "Input"],
Cell[19456, 638, 98, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19591, 644, 270, 8, 31, "Input"],
Cell[19864, 654, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19971, 660, 295, 9, 31, "Input"],
Cell[20269, 671, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20376, 677, 546, 17, 52, "Input"],
Cell[20925, 696, 3931, 112, 121, "Output"],
Cell[24859, 810, 514, 16, 56, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25410, 831, 568, 18, 52, "Input"],
Cell[25981, 851, 1146, 35, 56, "Output"],
Cell[27130, 888, 120, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27287, 895, 266, 8, 31, "Input"],
Cell[27556, 905, 91, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27684, 912, 293, 9, 31, "Input"],
Cell[27980, 923, 94, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28111, 930, 207, 5, 31, "Input"],
Cell[28321, 937, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28428, 943, 393, 12, 52, "Input"],
Cell[28824, 957, 997, 30, 52, "Output"],
Cell[29824, 989, 630, 20, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30491, 1014, 206, 5, 31, "Input"],
Cell[30700, 1021, 70, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30807, 1027, 393, 12, 52, "Input"],
Cell[31203, 1041, 1009, 31, 56, "Output"],
Cell[32215, 1074, 724, 23, 56, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
